/*
 * dsp.cpp
 *
 *  Created on: 29 mar 2023
 *      Author: Tomek
 */
/*****************************************************************************************************************************************/
#include "app.h"
#include "dsp.hpp"
//#include "gui.h"

#define T_PA  ((float)100/FP)
#define P_KOMP	((float)0.01)
#define T_KOMP	((float)30/FP)

#define PomiarAmplitudy(n,x)\
	static float n##BA = 0;\
	static float n##C1 = 0;\
	n##C1 += (((x<0) ? -x :x)-n##C1)*T_PA;\
	n##BA += (n##C1-n##BA)*T_PA;

#define Filtr(f,q,x)\
		static float uc##f = 0;\
		static float IL##f = 0;\
		uc##f += IL##f * (float)((float)2 * STALA_PI / FP * (float)q * (float)f);\
		IL##f += (x - uc##f - IL##f) * (float)((float)2 * STALA_PI / FP * (float)f / (float)q);\



SParFuzz ParFuzz = {0.5,0.5,0.05,0.5,0.5,0.5,0.5,0.5,0.5,0,0,0,0,true};

void __attribute__((section("RamFunction"))) PrzetwarzanieGlowne()
{
	volatile register float wl,wp;
	wl = (float)WartoscWE_L/(float)0x7FFF;
	wp = (float)WartoscWE_P/(float)0x7FFF;

	volatile register float ww = 0, wsp, ba, we = wl+wp, fk = 1/ParFuzz.Odc;

	if(ParFuzz.Komp)
	{
		static float ka = 0, kwl = 0;

		PomiarAmplitudy(wy_,we);

		if(wy_BA>P_KOMP) kwl = 1;
		if(wy_BA<P_KOMP/(float)2) kwl = 0;

		ka += (kwl-ka)*T_KOMP;
		we*=ka;
	}

	Filtr(21,1,we);
	PomiarAmplitudy(P20_,IL21);
	ba = P20_BA;
	wsp = IL21*fk;
	ww += ((ba<wsp) ? ba : ((-ba>wsp) ? -ba : wsp))*ParFuzz.A20;

	Filtr(46,1,we);
	PomiarAmplitudy(P50_,IL46);
	ba = P50_BA;
	wsp = IL46*fk;
	ww += ((ba<wsp) ? ba : ((-ba>wsp) ? -ba : wsp))*ParFuzz.A50;

	Filtr(100,1,we);
	PomiarAmplitudy(P100_,IL100);
	ba = P100_BA;
	wsp = IL100*fk;
	ww += ((ba<wsp) ? ba : ((-ba>wsp) ? -ba : wsp))*ParFuzz.A100;

	Filtr(215,1,we);
	PomiarAmplitudy(P200_,IL215);
	ba = P200_BA;
	wsp = IL215*fk;
	ww += ((ba<wsp) ? ba : ((-ba>wsp) ? -ba : wsp))*ParFuzz.A200;

	Filtr(464,1,we);
	PomiarAmplitudy(P500_,IL464);
	ba = P500_BA;
	wsp = IL464*fk;
	ww += ((ba<wsp) ? ba : ((-ba>wsp) ? -ba : wsp))*ParFuzz.A500;

	Filtr(1000,1,we);
	PomiarAmplitudy(P1K_,IL1000);
	ba = P1K_BA;
	wsp = IL1000*fk;
	ww += ((ba<wsp) ? ba : ((-ba>wsp) ? -ba : wsp))*ParFuzz.A1K;

	Filtr(2150,1,we);
	PomiarAmplitudy(P2K_,IL2150);
	ba = P2K_BA;
	wsp = IL2150*fk;
	ww += ((ba<wsp) ? ba : ((-ba>wsp) ? -ba : wsp))*ParFuzz.A2K;

	Filtr(4640,1,we);
	PomiarAmplitudy(P5K_,IL4640);
	ba = P5K_BA;
	wsp = IL4640*fk;
	ww += ((ba<wsp) ? ba : ((-ba>wsp) ? -ba : wsp))*ParFuzz.A5K;

	Filtr(10000,1.5,we);
	PomiarAmplitudy(P10K_,IL10000);
	ba = P10K_BA;
	wsp = IL1000*fk;
	ww += ((ba<wsp) ? ba : ((-ba>wsp) ? -ba : wsp))*ParFuzz.A10K;

	WartoscWY_P = WartoscWY_L = (int16_t)(ww*(float)0x7FFF);
}



